<?php
namespace CodingMs\Ftm\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Thomas Deuling <typo3@coding.ms>, coding.ms
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Core\Utility\GeneralUtility;
use \TYPO3\CMS\Extbase\Utility\LocalizationUtility;

/**
 *
 *
 * @package ftm
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class ParsedownController extends \CodingMs\Ftm\Controller\BaseController {

	/**
	 * Parse a Markdown file and display the result
	 *
	 * @return void
	 */
	public function showAction() {

		// typo3conf/ext/ftm_ext_addresslist/Readme.md
		$markdownFile = GeneralUtility::getFileAbsFileName($this->settings['markdownFile']);
		$markdown = LocalizationUtility::translate('tx_ftm_message.warning_parsedown_file_not_found', 'Ftm');;
		if ($markdownFile) {
			if (class_exists('\Parsedown')) {
				$parsedown = new \Parsedown();
				$markdown = $parsedown->text(file_get_contents($markdownFile));
			}
			else {
				$translation = LocalizationUtility::translate('tx_ftm_exception.parsedown_parser_not_found', 'Ftm');
				throw new \Exception($translation);
			}
		}

		// Protect E-Mail addresses
		$pattern = '/[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i';
		preg_match_all($pattern, $markdown, $matches);
		if(!empty($matches)) {
			$emails = array_unique($matches[0]);
		}
		if(!empty($emails)) {
			foreach($emails as $email) {
				list($linkHref, $linkText) = $GLOBALS['TSFE']->cObj->getMailTo($email, $email);
				$markdown = str_replace('mailto:' . $email, $linkHref, $markdown);
				$markdown = str_replace('>' . $email . '</a>', '>' . $linkText . '</a>', $markdown);
			}
		}
		
		$this->view->assign('markdown', $markdown);
	}

}
?>