<?php
namespace CodingMs\Ftm\Utility;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012 Thomas Deuling <typo3@coding.ms>, coding.ms
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Authorization Tools
 *
 * @package    ftm
 * @subpackage Utility
 */
class Authorization {

	/**
	 * Checks if a backend user is an admin user
	 * @return boolean
	 */
	public static function isAdmin() {
		if (isset($GLOBALS['BE_USER'])) {
			if (isset($GLOBALS['BE_USER']->user)) {
				return (bool)$GLOBALS['BE_USER']->user['uid'];
				//return (bool)$GLOBALS['BE_USER']->user['is_admin'];
			}
		}
		return FALSE;
	}

	/**
	 * Frontend user login
	 * @param $username \string Frontend user username
	 * @param $password \string Frontend user password
	 */
	public static function feUserLogin($username, $password) {

		$check = FALSE;
		$loginData = array(
			'username' => $username,
			'uident_text' => $password,
			'status' => 'login',
		);

		$GLOBALS['TSFE']->fe_user->checkPid = ''; //do not use a particular pid
		$info = $GLOBALS['TSFE']->fe_user->getAuthInfoArray();
		$user = $GLOBALS['TSFE']->fe_user->fetchUserRecord($info['db_user'], $loginData['username']);
		if( $GLOBALS['TSFE']->fe_user->compareUident($user, $loginData)) {
			$GLOBALS["TSFE"]->fe_user->createUserSession($user);
			$check = TRUE;
		}
		return $check;
	}

	/**
	 * Frontend user logout
	 * @param $uid \int Frontend user uid
	 */
	public static function feUserLogout($uid) {
		/**
		 * @todo: delete db-session
		$GLOBALS["TSFE"]->fe_user->user = NULL;
		$GLOBALS['TSFE']->loginUser = 0;
		$GLOBALS["TSFE"]->fe_user->loginSessionStarted = FALSE;
		 */


		$GLOBALS["TSFE"]->fe_user->logoff();
		
	}
}

?>