<?php
if (!defined('TYPO3_MODE')) {
    die ('Access denied.');
}

global $_EXTKEY;
global $TYPO3_CONF_VARS;

$configuration = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['ftm']);

/**
 * Registers a Backend Module
 */
if(!isset($configuration) || $configuration['disableBackendModule']!='1') {
	\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerModule(
		'CodingMs.'.$_EXTKEY,
		'tools',  // Make module a submodule of 'tools'
		'ftm',    // Submodule key
		'999',    // Position
		array(
			'Overview' => 'index',
			'Settings' => 'edit,save',
			'Services' => 'index',
			'Theme' => 'newTheme,createTheme,newFile,newFileAjax,deleteFile,saveSnippet,editFile,saveFile',
		),
		array(
			'access' => 'user,group',
			'icon'   => 'EXT:' . $_EXTKEY . '/ext_icon.gif',
			'labels' => 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/locallang_ftm.xml',
		)
	);
}

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	$_EXTKEY,
	'Parsedown',
	'FTM - Parsedown (Markdown)'
);

// Include flex forms
$pluginName='Parsedown'; // siehe Tx_Extbase_Utility_Extension::registerPlugin
$extensionName = \TYPO3\CMS\Core\Utility\GeneralUtility::underscoredToUpperCamelCase($_EXTKEY);
$pluginSignature = strtolower($extensionName) . '_'.strtolower($pluginName);
$TCA['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue($pluginSignature, 'FILE:EXT:'.$_EXTKEY.'/Configuration/FlexForms/Parsedown.xml');




/***************
 * Extend configuration
 */
// Add Rootline fields for default meta-tags
$TYPO3_CONF_VARS['FE']['addRootLineFields'] 
	= 'abstract,keywords,description,author,author_email,backend_layout_next_level,' . $TYPO3_CONF_VARS['FE']['addRootLineFields'];
$TYPO3_CONF_VARS['FE']['addRootLineFields'] 
	= implode(',', array_unique(explode(',', $TYPO3_CONF_VARS['FE']['addRootLineFields'])));

// Additional file types
$additionalFileTypes = 'html,css,less,sass,scss,ts,setupts,constantsts,pagets,userts,yaml,rst,';
$TYPO3_CONF_VARS['BE']['fileExtensions']['webspace']['allow'] 
	= implode(',', array_unique(explode(',', $additionalFileTypes . $TYPO3_CONF_VARS['BE']['fileExtensions']['webspace']['allow'])));
$TYPO3_CONF_VARS['SYS']['textfile_ext'] 
	= implode(',', array_unique(explode(',', $additionalFileTypes . $TYPO3_CONF_VARS['SYS']['textfile_ext'])));



// FTM Version
if(!defined('FTM_VERSION')) {
	define('FTM_VERSION', '3.0.2');
}


/*
// Include flex forms
$pluginName='Ftm'; // siehe \TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin
$extName = \TYPO3\CMS\Core\Utility\GeneralUtility::underscoredToUpperCamelCase($_EXTKEY);
$pluginSignature = strtolower($extName) . '_'.strtolower($pluginName);
$TCA['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue($pluginSignature, 'FILE:EXT:'.$_EXTKEY.'/Configuration/FlexForms/ExtConf.xml');
*/

// Include Static
//\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile($_EXTKEY, 'Configuration/TypoScript', 'FTM');






// make static files field bigger
$TCA['sys_template']['columns']['include_static_file']['config']['size'] = 20;
$TCA['sys_template']['columns']['include_static_file']['config']['maxitems'] = 999;

// we need more than 20 tables to be edited by the backend users...
$TCA['be_groups']['columns']['tables_modify']['config']['maxitems'] = 99;
$TCA['be_groups']['columns']['tables_select']['config']['maxitems'] = 99;





\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_theme', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_theme.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_theme');
$GLOBALS['TCA']['tx_ftm_domain_model_theme'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme.xlf:tx_ftm_domain_model_theme',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/Theme.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_theme.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themelink', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themelink.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themelink');
$GLOBALS['TCA']['tx_ftm_domain_model_themelink'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_link.xlf:tx_ftm_domain_model_themelink',
		'label' => 'uri',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'uri,title,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeLink.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themelink.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themekeyword', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themekeyword.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themekeyword');
$GLOBALS['TCA']['tx_ftm_domain_model_themekeyword'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_keyword.xlf:tx_ftm_domain_model_themekeyword',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'name,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeKeyword.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themekeyword.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themeextension', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themeextension.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themeextension');
$GLOBALS['TCA']['tx_ftm_domain_model_themeextension'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_extension.xlf:tx_ftm_domain_model_themeextension',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'name,version,description,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeExtension.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themeextension.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themelicense', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themelicense.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themelicense');
$GLOBALS['TCA']['tx_ftm_domain_model_themelicense'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_license.xlf:tx_ftm_domain_model_themelicense',
		'label' => 'license',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'license,license_uri,description,resources,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeLicense.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themelicense.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themelicenseresource', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themelicenseresource.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themelicenseresource');
$GLOBALS['TCA']['tx_ftm_domain_model_themelicenseresource'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_license_resource.xlf:tx_ftm_domain_model_themelicenseresource',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'name,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeLicenseResource.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themelicenseresource.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themeauthor', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themeauthor.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themeauthor');
$GLOBALS['TCA']['tx_ftm_domain_model_themeauthor'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_author.xlf:tx_ftm_domain_model_themeauthor',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'name,email,company,company_logo,company_website,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeAuthor.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themeauthor.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themescreenshot', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themescreenshot.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themescreenshot');
$GLOBALS['TCA']['tx_ftm_domain_model_themescreenshot'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_screenshot.xlf:tx_ftm_domain_model_themescreenshot',
		'label' => 'file',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'file,caption,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeScreenshot.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themescreenshot.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themeconstants', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themeconstants.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themeconstants');
$GLOBALS['TCA']['tx_ftm_domain_model_themeconstants'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_constants.xlf:tx_ftm_domain_model_themeconstants',
		'label' => 'available_categories',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'available_categories,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeConstants.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themeconstants.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_themeconstantscategory', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_themeconstantscategory.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_themeconstantscategory');
$GLOBALS['TCA']['tx_ftm_domain_model_themeconstantscategory'] = array(
	'ctrl' => array(
		'title'	=> 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.theme_constants_category.xlf:tx_ftm_domain_model_themeconstantscategory',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

		'adminOnly' => 1,
		'rootLevel' => 1,
		'hideTable' => 1,

		'versioningWS' => 2,
		'versioning_followPages' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'searchFields' => 'name,',
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/ThemeConstantsCategory.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_themeconstantscategory.gif'
	),
);

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addLLrefForTCAdescr('tx_ftm_domain_model_log', 'EXT:ftm/Resources/Private/Language/locallang_csh_tx_ftm_domain_model_log.xlf');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages('tx_ftm_domain_model_log');
$TCA['tx_ftm_domain_model_log'] = array(
	'ctrl' => array(
		'title' => 'LLL:EXT:ftm/Resources/Private/Language/locallang_db.log.xlf:tx_ftm_domain_model_log',
		'label' => 'extension_name',
		'label_alt' => 'action',
		'label_alt_force' => true,
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,
		'versioningWS' => 2,
		'versioning_followPages' => TRUE,
		'origUid' => 't3_origuid',
		'languageField' => 'sys_language_uid',
		'transOrigPointerField' => 'l10n_parent',
		'transOrigDiffSourceField' => 'l10n_diffsource',
		'delete' => 'deleted',
		'enablecolumns' => array(
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		),
		'dynamicConfigFile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Configuration/TCA/Log.php',
		'iconfile' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Icons/tx_ftm_domain_model_log.png'
	),
);